var m_button = false;
var m_inited = false;
var m_prefs = false;
var m_pb_prefs = false;
var m_pb_logger = false;

function proxybutton_switchProxy() {
    proxybutton_log(1, 'called switchProxy()');
    if (!m_inited || !m_button) {
        proxybutton_init();
    }

    var nCurProxyType = m_prefs.getIntPref("network.proxy.type");
    if (nCurProxyType == 0) {
        proxybutton_setManual();
    } else {
        proxybutton_setDirect();
    }
}

function proxybutton_init() {
    proxybutton_log(1, 'called init()');
    if (!m_prefs) {
    	proxybutton_initPrefObjects();
    }
    proxybutton_checkPreferencesExist();
    if (!m_button) {
       if (document.getElementById("proxybutton-button")) {
            m_button = document.getElementById("proxybutton-button");
       } else if (document.getElementById("proxybutton-button-tb")) {
            m_button = document.getElementById("proxybutton-button-tb");
       } else {
            m_button = document.getElementById("proxybutton-button-tb-msg");
       }
    }
    if (!m_inited) {
       var rObserver = {
          observe : function(subject, topic, data) { proxybutton_setButtonFromPreference(); }
       };
       var rPrefs  = Components.classes["@mozilla.org/preferences-service;1"].
            createInstance(Components.interfaces.nsIPrefBranchInternal);
       rPrefs.addObserver("network.proxy", rObserver, false);
    
       m_inited = true;
    }
    
    if (!m_pb_logger) {
        try {
            var logMngr = Components.classes["@mozmonkey.com/debuglogger/manager;1"].
                    getService(Components.interfaces.nsIDebugLoggerManager); 
            m_pb_logger = logMngr.registerLogger("proxybutton");
        } catch (exErr) {
            m_pb_logger = false;
        }
    }
    proxybutton_setButtonFromPreference();
}

function proxybutton_setButtonFromPreference() {
    var nCurProxyType = m_prefs.getIntPref("network.proxy.type");
    if (nCurProxyType == 0) {
        proxybutton_changeImage(0);
    } else {
        proxybutton_changeImage(1);
    }

}

function proxybutton_setDirect() {
    proxybutton_log(1, 'called setDirect()');
    m_prefs.setIntPref("network.proxy.type", 0);
}

function proxybutton_changeImage(nToType) {
    var sPrefix;

    proxybutton_log(1, 'called changeImage()');
    if (nToType==0) {
        m_button.setAttribute('pbstatus', 'off');
        m_button.setAttribute('tooltiptext', 'Turn proxy on');
    } else {
        m_button.setAttribute('pbstatus', 'on');
        m_button.setAttribute('tooltiptext', 'Turn proxy off');
    }
}

function proxybutton_setManual() {
    proxybutton_log(1, 'called setManual()');
    var proxyCurType = m_pb_prefs.getIntPref('proxytype');
    m_prefs.setIntPref("network.proxy.type", proxyCurType);
    if (proxyCurType == 2 && m_pb_prefs.getBoolPref('autoreload')) {
        // Autoreload enabled and autoproxy turned on - do it
        proxybutton_autoReloadProxy();
    }
}

function proxybutton_autoReloadProxy() {
    proxybutton_log(1, 'called autoReloadProxy()');
    
    var autoURL = m_prefs.getCharPref('network.proxy.autoconfig_url');
    var nsIProtocolProxyService = Components.interfaces.nsIProtocolProxyService;
    var kPROTPROX_CID = '{e9b301c0-e0e4-11D3-a1a8-0050041caf44}';
    
    var pps = Components.classesByID[kPROTPROX_CID].getService(nsIProtocolProxyService);
    pps.configureFromPAC(autoURL);
}

function proxybutton_initPrefObjects() {
    m_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

    m_pb_prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    m_pb_prefs = m_pb_prefs.getBranch("extensions.proxybutton.");
}

function proxybutton_initPreferences(pb_pref_radio, pb_pref_reload) {
    if (!m_prefs) {
        proxybutton_initPrefObjects();
    }
    proxybutton_checkPreferencesExist();
    
    pb_pref_radio.selectedIndex = m_pb_prefs.getIntPref('proxytype')-1;
    pb_pref_reload.checked = m_pb_prefs.getBoolPref('autoreload');
}

function proxybutton_savePreferences(pb_pref_radio, pb_pref_reload) {
    m_pb_prefs.setIntPref('proxytype', pb_pref_radio.selectedItem.value);
    m_pb_prefs.setBoolPref('autoreload', pb_pref_reload.checked);
}

function proxybutton_checkPreferencesExist() {
    try {
        m_pb_prefs.getIntPref('proxytype');
    } catch (rErr) {
        // Got exception - it seems that there's no such preference. Smash it in.
        m_pb_prefs.setIntPref('proxytype', 1);
    }

    try {
        m_pb_prefs.getBoolPref('autoreload');
    } catch (rErr) {
        // Got exception - it seems that there's no such preference. Smash it in.
        m_pb_prefs.setBoolPref('autoreload', 0);
    }
}

function proxybutton_log(nLevel, sMsg) {
    if (m_pb_logger) {
        m_pb_logger.log(nLevel, sMsg);
    }
}